----------------------------------------------------------------------------------
--  
--        apb-2_pai_top.vhd        APB-2 top Kw
--  
--        (c)2011/08/19  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;



entity apb_2_pai is
  port (
    EXTCLK12  : in  std_logic;                       -- P83     12MHziMC9S08 j NbN
    RESET_X   : in  std_logic;                       -- P29/VS2 _Zbg
    MOSI      : in  std_logic;                       -- P46     FPGA <- CPU
    CS_X      : in  std_logic;                       -- P48/INIT_B
    MISO      : inout std_logic;                     -- P51     FPGA -> CPU
    CCLK      : in  std_logic;                       -- P53
    
    RUNNING   : out std_logic;                       -- P3  
    TESTLED   : out std_logic;                       -- P30 VS1
    
    
    -- ȉ͖gps -------------------------------------------------------------------------------
    
--    P3        : in std_logic;
    P4        : in std_logic;
    P5        : in std_logic;
    P6        : in std_logic;
    P7        : in std_logic;
    P9        : in std_logic;
    P10       : in std_logic;
    P12       : in std_logic;
    P13       : in std_logic;
    P15       : in std_logic;
    P16       : in std_logic;
    P19       : in std_logic;
    P20       : in std_logic;
    P21       : in std_logic;                     -- ͐p
    P23       : in std_logic;                     -- M1
    P24       : in std_logic;                     -- M2
    P25       : in std_logic;                     -- M0
    P27       : in std_logic;                     -- CSO_B
    P28       : in std_logic;
--    P29       : in std_logic;                     -- VS2
--    P30       : in std_logic;                     -- VS1
    P31       : in std_logic;                     -- VS0
    P32       : in std_logic;
    P33       : in std_logic;
    P34       : in std_logic;
    P35       : in std_logic;
    P36       : in std_logic;
    P37       : in std_logic;
    P39       : in std_logic;                     -- ͐p
    P40       : in std_logic;
    P41       : in std_logic;
    P43       : in std_logic;
    P44       : in std_logic;
--    P46       : in std_logic;                     -- MOSI
--    P48       : in std_logic;                     -- INIT_B
    P49       : in std_logic;
    P50       : in std_logic;
--    P51       : in std_logic;                       -- MISO
    P52       : in std_logic;
--    P53       : in std_logic;                       -- CCLK
    P56       : in std_logic;
    P57       : in std_logic;
    P59       : in std_logic;
    P60       : in std_logic;
    P61       : in std_logic;
    P62       : in std_logic;
    P64       : in std_logic;
    P65       : in std_logic;
    P68       : in std_logic;                     -- ͐p
    P70       : in std_logic;
    P71       : in std_logic;
    P72       : in std_logic;
    P73       : in std_logic;
    P77       : in std_logic;
    P78       : in std_logic;
    P82       : in std_logic;                     -- ͐p
--    P83       : in std_logic;                     -- EXTCLK12MHz
    P84       : in std_logic;
    P85       : in std_logic;
    P86       : in std_logic;
    P88       : in std_logic;
    P89       : in std_logic;
    P90       : in std_logic;
    P93       : in std_logic;
    P94       : in std_logic;
    P97       : in std_logic;                     -- ͐p
    P98       : in std_logic;
    P99       : in std_logic                      -- PUDC_B
  );
end apb_2_pai;


architecture RTL of apb_2_pai is
  
  signal RESET        : std_logic;
  signal CLK84       : std_logic;
  signal CNT32        : std_logic_vector (31 downto 0);
  
  signal SO       : std_logic;
  
  signal MWE      : std_logic;                      -- Module Write Enable
  signal MCE      : std_logic_vector(15 downto 0);  -- Module Chip Enable
  signal MWDATA   : std_logic_vector(7 downto 0 );  -- W[݃f[^
  signal MRDATA   : std_logic_vector(7 downto 0 );  -- W[ǂݏof[^
  signal MADR     : std_logic_vector(15 downto 0);  -- W[AhX
  signal MEM_WE   : std_logic_vector(0 downto 0);  -- 
  
  signal ADOUT    : std_logic;
  
  signal SIG_RDATA : std_logic_vector(7 downto 0); -- signature ̓ǂݏof[^
  
  signal COS      : std_logic_vector(17 downto 0); -- dds1 o
  signal SIN      : std_logic_vector(17 downto 0); -- dds1 o
  signal DDS_L    : std_logic_vector(15 downto 0); -- dds3 o
  signal DDS_R    : std_logic_vector(15 downto 0); -- dds3 o
  
  signal LAMWDATA : std_logic_vector(31 downto 0); -- [ɏރf[^
  signal LAMWE    : std_logic;                     -- Memory Write Enable
  signal LATRG    : std_logic;                     -- gK[v
  signal LAIN     : std_logic_vector(31 downto 0); -- Logiana digital inputs
  signal LA_RDATA : std_logic_vector(7 downto 0); -- LOGIANA ̓ǂݏof[^
  
  signal FREQMEMWDATA : std_logic_vector(31 downto 0); -- Freq_det [ɏރf[^
  signal FREQMEMWE    : std_logic;                     -- Freq_det Memory Write Enable
  signal FREQTRG      : std_logic;                     -- gK[
  
  signal FC_RDATA  : std_logic_vector(7 downto 0); -- Freq Counter ̓ǂݏof[^
  signal FDET_RDATA: std_logic_vector(7 downto 0); -- FreqDet ̓ǂݏof[^
  
  signal DET_OUT  : std_logic_vector(15 downto 0); -- freqdet o
  
  signal CPU_RDATA : std_logic_vector(7 downto 0); -- cpu ̓ǂݏof[^
  
  signal DEBUG    : std_logic;
  
  
  COMPONENT dcm_84M
  PORT(
    CLKIN_IN : IN std_logic;
    RST_IN : IN std_logic;          
    CLKFX_OUT : OUT std_logic;
    CLKFX180_OUT : OUT std_logic;
    CLKIN_IBUFG_OUT : OUT std_logic;
    CLK0_OUT : OUT std_logic;
    CLK2X_OUT : OUT std_logic;
    LOCKED_OUT : OUT std_logic
    );
  END COMPONENT;
  
  
  component counter32
    port (
      RESET   : in  std_logic;                      -- 񓯊Zbg
      CLK     : in  std_logic;                      -- clock
      COUNT   : out std_logic_vector(31 downto 0 )  -- JEgl
    );
  end component;
  
  
  component spi
    port (
      RESET   : in  std_logic;
      CLK     : in  std_logic;                        -- I/O bus clock
      
      CS_X    : in  std_logic;                        -- Chip Select 
      SCK     : in  std_logic;                        -- Serial Clock
      SI      : in  std_logic;                        -- Serial IN
      SO      : out std_logic;                        -- Serial OUT
      
      MWE     : out std_logic;                        -- Module Write Enable
      MCE     : out std_logic_vector(15 downto 0 );   -- Module Enable
      MWDATA  : out std_logic_vector(7 downto 0 );    -- W[݃f[^
      MRDATA  : in  std_logic_vector(7 downto 0 );    -- W[ǂݏof[^
      MADR    : out std_logic_vector(15 downto 0 );   -- W[AhX
      
      DEBUG   : out std_logic                        -- 
    );
  end component;
  
  
  component signature 
    port (
      CLK      : in  std_logic;                      -- I/O clock
      
      MCE      : in  std_logic;                      -- module select
      MWE      : in  std_logic;                      -- Module Write Enable
      MADR     : in  std_logic_vector(15 downto 0);  -- address bus
      MWDATA   : in  std_logic_vector(7 downto 0 );  -- W[݃f[^
      MRDATA   : out std_logic_vector( 7 downto 0)   -- data bus output
    );
  end component;
  
  
  component cpu
    port (
      RESET   : in  std_logic;
      CLK2X   : in  std_logic;
      CLK     : in  std_logic;
      
      RUNNING : out std_logic;
      
      CE      : in  std_logic;
      WE      : in  std_logic;
      ADR     : in  std_logic_vector (15 downto 0);
      MWDATA  : in  std_logic_vector(7 downto 0);   -- W[݃f[^
      MRDATA  : out std_logic_vector(7 downto 0)    -- W[ǂݏof[^
    );
  end component;
  
  
begin

  U0: dcm_84M PORT MAP(
    CLKIN_IN        => EXTCLK12,
    RST_IN          => RESET,
    CLKFX_OUT       => CLK84,
    CLKFX180_OUT    => open,
    CLKIN_IBUFG_OUT => open,
    CLK0_OUT        => open,
    CLK2X_OUT       => open,
    LOCKED_OUT      => open
  );
  
  
  U1: counter32
  port map(
    RESET   => RESET,                   -- 񓯊Zbg
    CLK     => CLK84,                  -- clock
    COUNT   => CNT32                    -- JEgl
  );
  
  
  U2: spi
  port map(
    RESET   => RESET,
    CLK     => CLK84,                  -- I/O bus clock
    
    CS_X    => CS_X,                    -- Chip Select 
    SCK     => CCLK,                    -- Serial Clock
    SI      => MOSI,                    -- Serial IN
    SO      => SO,                      -- Serial OUT
    
    MWE     => MWE,                     -- Module Write Enable
    MCE     => MCE,                     -- Module Enable
    MWDATA  => MWDATA,                  -- W[݃f[^
    MRDATA  => MRDATA,                  -- W[ǂݏof[^
    MADR    => MADR,                    -- W[AhX
    
    DEBUG   => DEBUG                        -- 
  );
  
  
  M0 : signature
  port map (
    CLK      => CLK84,
    
    MCE      => MCE(0),                 -- Module Chip Enable  Addrs=0x00xx
    MWE      => MWE,                    -- Module Write Enable
    MADR     => MADR,                   -- W[AhX
    MWDATA   => MWDATA,                 -- W[݃f[^
    MRDATA   => SIG_RDATA               -- data bus output
  );
  
  
  M7 : cpu
  port map (
    RESET   => RESET,
    CLK2X   => CLK84,
    CLK     => CLK84,
    
    RUNNING => RUNNING,
    
    CE      => MCE(7),              -- Module Chip Enable  Addrs=0x07xx
    WE      => MWE,
    ADR     => MADR(15 downto 0),
    MWDATA  => MWDATA,
    MRDATA  => CPU_RDATA
  );
  
  
  MRDATA <= SIG_RDATA or CPU_RDATA;
  
  MISO <= SO when( CS_X='0' ) else 'Z'; -- 3state output
  
  RESET <= not RESET_X;
  TESTLED <= CNT32(25);     -- P30
  
  
end RTL;

