----------------------------------------------------------------------------------
--  
--        cpu.vhd        pai vZp{Z CPU
--  
--        (c)2011/08/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
----------------------------------------------------------------------------------
--
--  Register :  r0..15    16bit  r14SIZEAr15SP
--              size      16bit  {xw背WX^[
--              PC        16bit  vOJE^[
--
--  Flag :      Z         [
--              C         L[
--
--     OP(4) OPERAND(12)
--   0 MOV   m r0..15   m r0..15
--   1 ADD   m r0..15   m r0..15
--   2 SUB   m r0..15   m r0..15
--   3 CMP   m r0..15   m r0..15
--   4 AND   m r0..15   m r0..15        Ƃ肠svȂ̂ŎȂ
--   5 OR    m r0..15   m r0..15        Ƃ肠svȂ̂ŎȂ
--   6 XOR   m r0..15   m r0..15        Ƃ肠svȂ̂ŎȂ
--   7 NADD  m r0..15   m r0..15        Ƃ肠svȂ̂ŎȂ
--   8 MUL   m r0..15   m r0..15
--   9 DIV   m r0..15   m r0..15
--  10
--  11
--  12 BRA   c(3)    offset(9)           BRANCH  }256
--  12 PAUSE 100     xxxxxxxxx          ꎞ~(RUNR}h𑗂Ǝ̃AhXsĊJ)
--  13 JMP   adrs(12)                   0..4095
--  14 CALL  adrs(12)                   0..4095
--  15 RET   c(3) 0  xxxxxxxx            RET
--  15 PUSH    00x1  xxxx r0..15        WX^[ PUSH 
--  15 POP     10x1  xxxx r0..15        WX^[ POP 
--
--  ȉPUSH/POP͖
--  15 PUSHL   0101  r7..0              őWWX^[(ΉrbgP̃WX^[) PUSH 
--  15 PUSHH   0111  SIZE r14..8          V
--  15 POPL    1101  r7..0              őWWX^[(ΉrbgP̃WX^[) POP 
--  15 POPH    1111  SIZE r14..5          V
--
--  m : 00   WX^[   r
--      01   WX^[Ԑ   *r
--      10   WX^[ŎAhXsize{f[^   r[size]
--      11   l   0..14 ̓WX^[tB[hA15..65535 ͎̃AhX
--
--  c : 000  always
--      001  Z           ==0
--      010  C           <0
--      011  C or Z      <=0
--      100  
--      101  NZ          !=0
--      110  NC          >=0
--      111  NC and NZ   >0
--
----------------------------------------------------------------------------------
--
--Selected Device : 3s200avq100-5 
--
-- Number of Slices:                      916  out of   1792    51%  
-- Number of Slice Flip Flops:            535  out of   3584    14%  
-- Number of 4 input LUTs:               1487  out of   3584    41%  
-- Number of IOs:                          38
-- Number of bonded IOBs:                  37  out of     68    54%  
-- Number of BRAMs:                         8  out of     16    50%  
-- Number of MULT18X18SIOs:                 1  out of     16     6%  
-- Number of GCLKs:                         2  out of     24     8%  
--
--   Minimum period: 11.269ns (Maximum Frequency: 88.738MHz)
--   Minimum input arrival time before clock: 10.441ns
--   Maximum output required time after clock: 13.901ns
--   Maximum combinational path delay: 12.769ns
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity cpu is
  port (
    RESET   : in  std_logic;
    CLK2X   : in  std_logic;
    CLK     : in  std_logic;
    
    RUNNING : out std_logic;
    
    CE      : in  std_logic;
    WE      : in  std_logic;
    ADR     : in  std_logic_vector (15 downto 0);
    MWDATA  : in  std_logic_vector(7 downto 0);   -- W[݃f[^
    MRDATA  : out std_logic_vector(7 downto 0)    -- W[ǂݏof[^
  );
end cpu;


architecture RTL of cpu is
  
  signal CPU_RESET    : std_logic;                          -- 0:RUN          1:RESET
  signal PAUSE        : std_logic;                          -- 0:RUN          1:ꎞ~
  signal RUN          : std_logic;                          -- 0:STOP(DMA)  1:RUN
  signal STEP         : std_logic;                          -- STEPs
  signal MWDATA_H     : std_logic_vector(7 downto 0);       -- 
  
  signal PC           : std_logic_vector(15 downto 0);      -- 
  signal SIZE         : std_logic_vector(15 downto 0);      -- 
  signal SP           : std_logic_vector(15 downto 0);      -- = r15
  signal FLAG_Z       : std_logic;                          -- 
  signal FLAG_C       : std_logic;                          -- 
  
  signal FLAG_CHANGE  : std_logic;                          -- tOύX
  
  signal RX           : std_logic_vector(15 downto 0);      -- {Z̃|C^[ X
  signal RY           : std_logic_vector(15 downto 0);      -- {Z̃|C^[ Y
  signal RZ           : std_logic_vector(15 downto 0);      -- {Z̃[h Z
  
  signal R_NA         : std_logic_vector(3 downto 0);       -- WX^[ԍA
  signal R_NA_SP      : std_logic_vector(3 downto 0);       -- WX^[ԍA (X^bNŎg)
  signal R_NB         : std_logic_vector(3 downto 0);       -- WX^[ԍB
  signal R_DOUTA      : std_logic_vector(15 downto 0);      -- WX^[ǂݏof[^A
  signal R_DOUTB      : std_logic_vector(15 downto 0);      -- WX^[ǂݏof[^B
  signal R_DIN        : std_logic_vector(15 downto 0);      -- WX^[݃f[^
  signal R_WE         : std_logic;                          -- WX^[݃Cl[u
  signal R_DIN_SP     : std_logic_vector(15 downto 0);      -- WX^[݃f[^ SP
  
  signal M_DINA       : std_logic_vector(15 downto 0);
  signal M_ADDRA      : std_logic_vector(15 downto 0);
  signal M_WEA        : std_logic_vector(0 downto 0);
  signal M_DOUTA      : std_logic_vector(15 downto 0);
  signal M_DINB       : std_logic_vector(15 downto 0);
  signal M_ADDRB      : std_logic_vector(15 downto 0);
  signal M_WEB        : std_logic_vector(0 downto 0);
  signal M_DOUTB      : std_logic_vector(15 downto 0);
  signal M_WE         : std_logic;                          -- [݃Cl[u
  
  signal MC           : std_logic_vector(15 downto 0);      -- }V(Machine Code)
  signal MC1          : std_logic_vector(15 downto 0);      -- 
  signal MC_OP        : std_logic_vector(3 downto 0);       -- IyR[h
  signal MC_MA        : std_logic_vector(1 downto 0);       -- [h A
  signal MC_RA        : std_logic_vector(3 downto 0);       -- WX^[ A
  signal MC_MB        : std_logic_vector(1 downto 0);       -- [h B
  signal MC_RB        : std_logic_vector(3 downto 0);       -- WX^[ B
  signal MC_OFFSET    : std_logic_vector(15 downto 0);      -- BRA ItZbg
  signal MC_ADRS      : std_logic_vector(15 downto 0);      -- JMP/CALL AhX
  signal MC_DATAB     : std_logic_vector(15 downto 0);      -- \[Xf[^
  signal MC_CND       : std_logic_vector(2 downto 0);       -- 
  signal MC_CNDMATCH  : std_logic;                          -- vH
  signal IMMBIG_MODE  : std_logic;                          -- l(15..65535)[h
  signal IMM_DATA     : std_logic_vector(15 downto 0);      -- lf[^
  signal MC_OP_CMP    : std_logic;                          -- IyR[h CMP
  signal MC_OP_DIV    : std_logic;                          -- IyR[h DIV
  
  signal ALU_OP       : std_logic_vector(3 downto 0);       -- ZI
  signal ALU_INA      : std_logic_vector(15 downto 0);
  signal ALU_INB      : std_logic_vector(15 downto 0);
  signal ALU_INCARRY  : std_logic;                          -- L[
  signal ALU_DIVA     : std_logic_vector(31 downto 0);      -- Z 폜
  signal ALU_DIVND    : std_logic;                          -- Z ̓f[^L
  signal ALU_OUT      : std_logic_vector(15 downto 0);
  signal ALU_ZERO     : std_logic;
  signal ALU_CARRY    : std_logic;
--  signal ALU_MULOUT   : std_logic_vector(31 downto 0);      -- Zo
  signal ALU_MULOUT   : std_logic_vector(15 downto 0);      -- Zo
  signal ALU_DIVR     : std_logic_vector(15 downto 0);      -- Z ]
  signal ALU_DIVOD    : std_logic;                          -- Z o̓f[^L
  
  signal MP_OP        : std_logic_vector(3 downto 0);       -- { ZI
  signal MP_MULH      : std_logic_vector(15 downto 0);      -- { Zʂ̏16bit
  signal MP_TMP       : std_logic_vector(15 downto 0);      -- { Zʂ̏16bit
  signal MP_DIVR      : std_logic_vector(15 downto 0);      -- { Z]
  
  --------------------------------------------------------------------
  signal STATE  : integer range 0 to 7;           -- Xe[g
  constant S_FETCH    : integer := 0;             -- ߃tFb`
  constant S_DECODE   : integer := 1;             -- fR[h
  constant S_ALU      : integer := 2;             -- Z
  constant S_MULTIPREC: integer := 3;             -- {Z
  constant S_CALL     : integer := 4;             -- Tu[`R[
  constant S_RET      : integer := 5;             -- 
  constant S_PUSH     : integer := 6;             -- 
  constant S_POP      : integer := 7;             -- 
  
  --------------------------------------------------------------------
  signal SUBSTATE : integer range 0 to 7; 
  
  -- ZTuXe[g
  constant S_A0     : integer := 0;               -- 
  constant S_A1     : integer := 1;               -- 
  constant S_A2     : integer := 2;               -- 
  
  -- {ZTuXe[g
  constant S_MP0    : integer := 0;               -- 
  constant S_MP1    : integer := 1;               -- 
  constant S_MPMUL  : integer := 2;               -- 
  constant S_MPDIV1 : integer := 3;               -- 
  constant S_MPDIV2 : integer := 4;               -- 
  constant S_MPNEXT : integer := 5;               -- 
  
  -- CALL TuXe[g
  constant S_C0 : integer := 0;                   -- 
  constant S_C1 : integer := 1;                   -- 
  
  -- RET TuXe[g
  constant S_R0 : integer := 0;                   -- 
  constant S_R1 : integer := 1;                   -- 
  constant S_R2 : integer := 2;                   -- 
  
  -- PUSHPOP TuXe[g
  constant S_P0 : integer := 0;                   -- 
  constant S_P1 : integer := 1;                   -- 
  constant S_P2 : integer := 2;                   -- 
  constant S_P3 : integer := 3;                   -- 
  
  
  
  component ram_8k_16
    port (
      clka : in std_logic;
      WEA : in std_logic_vector(0 downto 0);
      ADDRA : in std_logic_vector(12 downto 0);
      DINA : in std_logic_vector(15 downto 0);
      DOUTA : out std_logic_vector(15 downto 0);
      clkb : in std_logic;
      WEB : in std_logic_vector(0 downto 0);
      ADDRB : in std_logic_vector(12 downto 0);
      DINB : in std_logic_vector(15 downto 0);
      DOUTB : out std_logic_vector(15 downto 0)
    );
  end component;
  
  
  component reg
    port (
    RESET       : in  std_logic;
    CLK         : in  std_logic;
    
    R_NA        : in  std_logic_vector (3 downto 0);  -- WX^[ԍ A
    R_NB        : in  std_logic_vector (3 downto 0);  -- WX^[ԍ B
    R_WE        : in  std_logic;                      -- WX^[ A ݃Cl[u
    R_DIN       : in  std_logic_vector (15 downto 0); -- WX^[ A ݃f[^
    
    R_DOUTA     : out std_logic_vector (15 downto 0); -- WX^[ǂݏof[^ A
    R_DOUTB     : out std_logic_vector (15 downto 0); -- WX^[ǂݏof[^ B
    R_14        : out std_logic_vector (15 downto 0); -- WX^[ SIZE(r14) ǂݏof[^
    R_15        : out std_logic_vector (15 downto 0)  -- WX^[ SP(r15) ǂݏof[^
    );
  end component;
  
  
  component alu
    port (
    RESET       : in  std_logic;
    CLK2X       : in  std_logic;
    CLK         : in  std_logic;
    
    ALU_OP      : in  std_logic_vector (3 downto 0);
    ALU_INA     : in  std_logic_vector (15 downto 0);
    ALU_INB     : in  std_logic_vector (15 downto 0);
    ALU_INCARRY : in  std_logic;                        -- L[
    ALU_DIVA    : in  std_logic_vector (31 downto 0);   -- Z 폜
    ALU_DIVND   : in  std_logic;                        -- Z ̓f[^L
    
    ALU_OUT     : out std_logic_vector (15 downto 0);
    ALU_CARRY   : out std_logic;
    ALU_ZERO    : out std_logic;
    ALU_MULOUT  : out std_logic_vector (15 downto 0);   -- Zo͏16bit
    ALU_DIVR    : out std_logic_vector (15 downto 0);   -- Z ]
    ALU_DIVOD   : out std_logic                         -- Z o̓f[^L
    );
  end component;
  
  
begin
  
  
  -----------------------------------------------------------------------------
  --    fR[h
  -----------------------------------------------------------------------------
  MC     <= M_DOUTB when( STATE=S_DECODE ) else
            MC1;
  
  MC_OP  <= MC(15 downto 12);           -- OP code
  MC_MA  <= MC(11 downto 10);           -- Mode A
  MC_RA  <= MC( 9 downto  6);           -- Register A
  MC_MB  <= MC( 5 downto  4);           -- Mode B
  MC_RB  <= MC( 3 downto  0);           -- Register B
  MC_CND <= MC(11 downto  9);           -- Condition
  MC_OFFSET <= MC(8)&MC(8)&MC(8)&MC(8)&MC(8)&MC(8)&MC(8)&MC(8 downto 0);
  MC_ADRS   <= "0000"&MC(11 downto 0);
  
  IMMBIG_MODE <= '1' when( MC_MB="11" and MC_RB="1111" ) else '0';    -- l(15..65535)[h
  
  IMM_DATA <= "000000000000"&MC_RB when( IMMBIG_MODE='0' ) else       -- l(0-14)
              M_DOUTB;                                                -- l(15..65535)
  
  MC_DATAB <= R_DOUTB   when( MC_MB="00" ) else   -- WX^[
              IMM_DATA  when( MC_MB="11" ) else   -- l
              M_DOUTB;                            -- WX^[Ԑ or {
  
  MC_CNDMATCH <= '1' when( MC_CND="000" ) else                                 -- always
                 '1' when( MC_CND="001" and FLAG_Z='1' ) else                  -- Z          ==0  EQ
                 '1' when( MC_CND="010" and FLAG_C='1' ) else                  -- C          <0   LT
                 '1' when( MC_CND="011" and (FLAG_C='1' or FLAG_Z='1') ) else  -- C or Z     <=0  LE
                 '1' when( MC_CND="101" and FLAG_Z='0' ) else                  -- NZ         !=0  NE
                 '1' when( MC_CND="110" and FLAG_C='0' ) else                  -- NC         >=0  GE
                 '1' when( MC_CND="111" and (FLAG_C='0' and FLAG_Z='0') ) else -- NC and NZ  >0   GT
                 '0';
  
  MC_OP_DIV <= '1' when( MC_OP=X"9" ) else '0';   -- DIV
  MC_OP_CMP <= '1' when( MC_OP=X"3" ) else '0';   -- CMP
  
  -----------------------------------------------------------------------------
  --    [  ǂݏ
  -----------------------------------------------------------------------------
  U0 : ram_8k_16
  port map (
    clka  => CLK,
    WEA   => M_WEA,
    ADDRA => M_ADDRA(12 downto 0),
    DINA  => M_DINA,
    DOUTA => M_DOUTA,
    
    clkb  => CLK,
    WEB   => M_WEB,
    ADDRB => M_ADDRB(12 downto 0),
    DINB  => M_DINB,
    DOUTB => M_DOUTB
  );
  
  
  M_ADDRA  <= RX when( STATE=S_MULTIPREC ) else   -- {Z
              R_DOUTA;
  
  M_ADDRB  <= "0"&ADR(15 downto 1) when( STATE = S_FETCH and RUN='0' ) else -- DMA
              PC when( IMMBIG_MODE = '1' ) else   -- ߃tFb` or l
              RY when( STATE=S_MULTIPREC ) else   -- {Z
              PC when( STATE /= S_DECODE ) else   -- ߃tFb` or l
              R_DOUTB;
  
  M_DINA   <= PC when( STATE = S_CALL ) else
              ALU_OUT(15 downto 0);
  
  M_DINB   <= MWDATA_H & MWDATA;                  -- DMA
  
  M_WEA(0) <= M_WE;
  M_WEB(0) <= '1' when( WE='1' and ADR(15)='1' and ADR(0)='1' and RUN='0' ) else  -- DMA
              '0';
  
  
  
  -----------------------------------------------------------------------------
  --    WX^[ r0..15  ǂݏ
  -----------------------------------------------------------------------------
  U1 : reg
  port map (
    RESET   => CPU_RESET,
    CLK     => CLK,
    
    R_NA    => R_NA,      -- WX^[ԍ A
    R_NB    => R_NB,      -- WX^[ԍ B
    R_WE    => R_WE,      -- WX^[ A ݃Cl[u
    R_DIN   => R_DIN,     -- WX^[ A ݃f[^
    
    R_DOUTA => R_DOUTA,   -- WX^[ǂݏof[^ A
    R_DOUTB => R_DOUTB,   -- WX^[ǂݏof[^ B
    R_14    => SIZE,      -- WX^[ SIZE(r14) ǂݏof[^
    R_15    => SP         -- WX^[ SP(r15) ǂݏof[^
  );
  
  
  R_NA  <=  X"F"    when( STATE=S_CALL or STATE=S_RET or STATE=S_PUSH ) else   -- SP(r15)
            R_NA_SP when( STATE=S_POP ) else
            MC_RA;
  
  R_NB  <=  ADR(4 downto 1) when( STATE=S_FETCH and RUN='0' ) else  -- DMA
            MC_RB;
  
  R_DIN <=  R_DIN_SP when( STATE=S_CALL or STATE=S_RET or STATE=S_PUSH or STATE=S_POP ) else
            ALU_OUT(15 downto 0);
  
  
  
  -----------------------------------------------------------------------------
  --    Zsi`ktj
  -----------------------------------------------------------------------------
  U2 : alu
  port map (
    RESET       => RESET,
    CLK2X       => CLK2X,
    CLK         => CLK,
    
    ALU_OP      => ALU_OP,
    ALU_INA     => ALU_INA,
    ALU_INB     => ALU_INB,
    ALU_INCARRY => ALU_INCARRY,         -- L[
    ALU_DIVA    => ALU_DIVA,            -- Z 폜
    ALU_DIVND   => ALU_DIVND,           -- Z ̓f[^L
    
    ALU_OUT     => ALU_OUT,
    ALU_CARRY   => ALU_CARRY,
    ALU_ZERO    => ALU_ZERO,
    ALU_MULOUT  => ALU_MULOUT,          -- Zo
    ALU_DIVR    => ALU_DIVR,            -- Z ]
    ALU_DIVOD   => ALU_DIVOD            -- Z o̓f[^L
  );
  
  ALU_OP <= MC_OP when( STATE /= S_MULTIPREC ) else
            MP_OP;
  
  -----------------------------------------------------------------------------
  --    bot̊eXe[g
  -----------------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( CPU_RESET='1') then
        PAUSE    <= '0';
        PC      <= ( others => '0');
        FLAG_Z  <= '0';
        FLAG_C  <= '0';
        STATE   <= S_FETCH;
      else
        case STATE is
          
          -- ߃tFb` ----------------------------------------------------------------------
          when( S_FETCH ) =>                      -- ߃tFb`
            if( FLAG_CHANGE='1' ) then
              FLAG_Z  <= ALU_ZERO;
              FLAG_C  <= ALU_CARRY;
            end if;
            FLAG_CHANGE <= '0';
            R_WE <= '0';
            M_WE <= '0';
            ALU_INCARRY <= '0';
--            SUBSTATE <= 0;
            R_NA_SP <= X"F";                      -- SP(r15) 
--            if( RUN='1' and PAUSE='0') then
            if( RUN='1' ) then
              PC  <= PC+1;
              STATE <= S_DECODE;
            else
              PAUSE <= '0';
            end if;
            
          -- fR[h ----------------------------------------------------------------------
          when( S_DECODE ) =>                     -- 
            MC1 <= M_DOUTB;                       -- ̃Xe[gŎgߖ߂b`
            SUBSTATE <= 0;
            
            case MC_OP is
              when( X"C" ) =>                     -- BRA
                if( MC_CNDMATCH='1' ) then
                  PC <= PC + MC_OFFSET;
                end if;
                if( MC_CND="100" ) then           -- PAUSE
                  PAUSE <= '1';
                end if;
                STATE<= S_FETCH;
                
              when( X"D" ) =>                     -- JMP
                PC <= MC_ADRS;
                STATE<= S_FETCH;
                
              when( X"E" ) =>                     -- CALL
                M_WE <= '1';                      -- PC X^bNɓ
                STATE <= S_CALL;
                
              when( X"F" ) =>
                if( MC(8)='0' ) then              -- RET
                  if( MC_CNDMATCH='1' ) then
                    R_DIN_SP <= SP + 1;           -- SP(r15)  +1 
                    R_WE <= '1';                  -- 
                    STATE <= S_RET;
                  else
                    STATE <= S_FETCH;
                  end if;
                elsif( MC(11)='0' ) then          -- PUSH
                  ALU_INB <= R_DOUTB;
                  M_WE <= '1';                    -- WX^[̓eX^bNɓ
                  STATE <= S_PUSH;
                else                              -- POP
                  R_DIN_SP <= SP + 1;             -- SP(r15)  +1 
                  R_WE <= '1';                    -- 
                  STATE <= S_POP;
                end if;
                
              when others =>                      -- Z
                if( MC_MA="10" ) then             -- {Z
                  if( MC_OP_DIV='1' ) then        -- DIV ͐擪AȊO͖牉Z
                    RX <= R_DOUTA;
                  else
                    RX <= R_DOUTA + SIZE;
                  end if;
                  if( MC_MB="10" ) then           -- {̂Ƃ͖牉Z
                    RY <= R_DOUTB + SIZE;
                  else
                    RY <= R_DOUTB;
                  end if;
                  RZ <= SIZE;
                  MP_MULH <= (others =>'0');      -- { Zʂ̏16bit
                  MP_DIVR <= (others =>'0');      -- { Z]
                  FLAG_Z <= '1';
                  STATE <= S_MULTIPREC;           -- {Z
                  
                else
                  STATE <= S_ALU;                 -- ʏ퉉Z
                  
                end if;
            end case;
            
          -- ʏ퉉ZXe[g ----------------------------------------------------------------------
          when( S_ALU ) =>
            case SUBSTATE is
              when( S_A0 ) =>
                if(MC_MA="00") then
                  ALU_INA  <= R_DOUTA;                      -- WX^[
                  ALU_DIVA <= "0000000000000000"&R_DOUTA;   -- Z 폜
                else
                  ALU_INA  <= M_DOUTA;                      -- WX^[Ԑ
                  ALU_DIVA <= "0000000000000000"&M_DOUTA;   -- Z 폜
                end if;
                
                ALU_INB <= MC_DATAB;
                
                if( IMMBIG_MODE ='1' ) then       -- l僂[ĥƂ͎̃AhX̖߂
                  PC <= PC + 1;
                end if;
                
                if( MC_OP_DIV = '1' ) then        -- DIV
                  ALU_DIVND <= '1';               -- Z Jn
                  SUBSTATE <= S_A1;
                else
                  if( MC_OP_CMP = '0' ) then      -- CMP ȊO͉Zʂ߂   CMP ̓tOω̂
                    if( MC_MA="00" ) then         -- WX^[ڂȂ
                      R_WE <= '1';                --   WX^[ɏ߂
                    else                          -- WX^[ԐڂȂ
                      M_WE <= '1';                --   [ɏ߂
                    end if;
                  end if;
                  
                  FLAG_CHANGE <= '1';
                  STATE<= S_FETCH;
                end if;
              when( S_A1 ) =>
                ALU_DIVND <= '0';                 -- Z Jn
                SUBSTATE  <= S_A2;
              when( S_A2 ) =>
                if( ALU_DIVOD = '1' ) then
                  if( MC_MA="00" ) then           -- WX^[ڂȂ
                    R_WE <= '1';                  --   WX^[ɏ߂
                  else                            -- WX^[ԐڂȂ
                    M_WE <= '1';                  --   [ɏ߂
                  end if;
                  
                  FLAG_CHANGE <= '1';
                  STATE<= S_FETCH;
                end if;
              when others =>                      -- ERROR
                STATE<= S_FETCH;
            end case;
            
          -- {ZXe[g ----------------------------------------------------------------------
          when( S_MULTIPREC ) =>
            case SUBSTATE is
              when( S_MP0 ) =>                    -- [ǂݏo 1clk Kv
                MP_OP <= MC_OP;                   -- ŏ̉Z͓
                SUBSTATE <= S_MP1;
              when( S_MP1 ) =>
                ALU_INA <= M_DOUTA;
                ALU_INB <= MC_DATAB;
                case MC_OP is
                  when( X"8" ) =>                 -- MUL
                    SUBSTATE <= S_MPMUL;
                  when( X"9" ) =>                 -- DIV
                    ALU_DIVA <= MP_DIVR & M_DOUTA;-- Z 폜
                    ALU_DIVND <= '1';             -- Z Jn
                    SUBSTATE <= S_MPDIV1;
                  when others =>                  -- 
                    if( MC_OP_CMP = '0' ) then    -- CMP ȊO
                      M_WE <= '1';                -- [ɏ߂
                    end if;
                    SUBSTATE <= S_MPNEXT;
                end case;
                
              when( S_MPMUL ) =>
                MP_TMP  <= ALU_MULOUT;            -- Z 16bit e|[ɕۑ
                ALU_INA <= ALU_OUT;               -- Z 16bit
                ALU_INB <= MP_MULH;
                MP_OP   <= X"1";                  -- ADD
                M_WE    <= '1';                   -- [ɏ߂
                SUBSTATE <= S_MPNEXT;
                
              when( S_MPDIV1 ) =>
                ALU_DIVND <= '0';
                SUBSTATE  <= S_MPDIV2;
              when( S_MPDIV2 ) =>
                if( ALU_DIVOD = '1' ) then        -- DIV ZI҂
                  SUBSTATE <= S_MPNEXT;
                  MP_DIVR  <= ALU_DIVR;
                  M_WE <= '1';
                end if;
                
              when( S_MPNEXT ) =>
                M_WE <= '0';
                FLAG_Z <= ALU_ZERO and FLAG_Z;    -- {f[^ׂĂ[̂Ƃ[tO𗧂Ă
                FLAG_C <= ALU_CARRY;              -- ŏIf[^̃L[L[tOɂȂ
                ALU_INCARRY <= ALU_CARRY;         -- ̃[h̉Zp̃L[
                MP_MULH <= MP_TMP;
                if( RZ=X"0000" ) then             -- {ZI?
                  STATE<= S_FETCH;
                else
                  if( MC_OP_DIV='1' ) then        -- DIV ̂Ƃ͐擪[hADIV ȊO͍ŏI[h牉Z
                    RX <= RX + 1;
                  else
                    RX <= RX - 1;
                  end if;
                  if( MC_MB="10" ) then           -- IyhQ{Ȃ -1  ( DIV ͍lȂ )
                    RY <= RY - 1;
                  end if;
                  RZ <= RZ - 1;
                  SUBSTATE <= S_MP0;
                end if;
                
              when others =>                      -- ERROR 
                STATE<= S_FETCH;
                
            end case;
            
          -- Tu[`R[ ------------------------------------------------------------
          when( S_CALL ) =>                       -- 
            case SUBSTATE is
              when( S_C0 ) =>
                M_WE <= '0';
                R_DIN_SP <= SP - 1;               -- SP(r15)  -1 
                R_WE <= '1';
                SUBSTATE <= S_C1;
              when( S_C1 ) =>
                R_WE <= '0';
                PC <= MC_ADRS;                    -- PC ݒ
                STATE<= S_FETCH;
              when others =>                      -- ERROR
                STATE<= S_FETCH;
            end case;
            
          -- ^[ ----------------------------------------------------------------------
          when( S_RET ) =>                        -- RET
            case SUBSTATE is
              when( S_R0 ) =>
                R_WE <= '0';
                SUBSTATE <= S_R1;
              when( S_R1 ) =>                     -- [̓ǂݏo1clk̂ő҂
                SUBSTATE <= S_R2;
              when( S_R2 ) =>
                PC <= M_DOUTA;                    -- X^bN PC ߂
                STATE <= S_FETCH;
              when others =>                      -- ERROR
                STATE <= S_FETCH;
            end case;
            
          -- PUSH ----------------------------------------------------
          when( S_PUSH ) =>                       -- 
            case SUBSTATE is
              when( S_P0 ) =>
                M_WE <= '0';
                R_DIN_SP <= SP - 1;               -- SP(r15)  -1 
                R_WE <= '1';
                SUBSTATE <= S_P1;
              when( S_P1 ) =>
                R_WE <= '0';
                STATE<= S_FETCH;
              when others =>                      -- ERROR
                STATE<= S_FETCH;
            end case;
            
          -- POP ----------------------------------------------------------------------
          when( S_POP ) =>                        -- 
            case SUBSTATE is
              when( S_P0 ) =>
                R_WE <= '0';
                SUBSTATE <= S_P1;
              when( S_P1 ) =>                     -- [̓ǂݏo1clk̂ő҂
                SUBSTATE <= S_P2;
              when( S_P2 ) =>
                R_NA_SP <= MC_RB;
                R_DIN_SP <= M_DOUTA;
                R_WE <= '1';                      -- X^bN烌WX^[߂
                SUBSTATE <= S_P3;
              when( S_P3 ) =>
                R_WE <= '0';
                STATE<= S_FETCH;
              when others =>                      -- ERROR
                STATE<= S_FETCH;
            end case;
            
          ------------------------------------------------------------------------
          when others =>                          -- ERROR
            STATE<= S_FETCH;
            
        end case;
      end if;
    end if;
  end process;
  
  
  
  ------------------------------------------------------------------
  --    ݒ & C^[tF[X
  -----------------------------------------------------------------------------
  MRDATA <= M_DOUTB(15 downto 8)  when(ADR(15)='1' and ADR(0)='0') else
            M_DOUTB( 7 downto 0)  when(ADR(15)='1' and ADR(0)='1') else
            "00000000"          when(CE='0') else
            R_DOUTB(15 downto 8) when(ADR(5)='1' and ADR(0)='0') else
            R_DOUTB( 7 downto 0) when(ADR(5)='1' and ADR(0)='1') else
            "00000" & FLAG_C &  FLAG_Z & RUN  when(ADR(1 downto 0)="00") else
            PC(15 downto 8)     when(ADR(1 downto 0)="10") else
            PC( 7 downto 0);
  
  RUNNING <= RUN;
  
  
  process( RESET, CLK ) begin
    if( RESET='1' ) then 
      CPU_RESET <= '1';                           -- CPU RESET
      STEP    <= '0';                             -- STEP ł͂Ȃ
      RUN     <= '0';                             -- STOP
    elsif( PAUSE='1' ) then                       -- ꎞ~
      RUN     <= '0';                             -- STOP
    elsif( rising_edge(CLK) ) then
      if( WE='1' and CE='1' ) then                -- 00:STOP  01:RESET  10:STEP   11:RUN
        case MWDATA(1 downto 0) is
          when( "00" ) =>                         -- STOP
            RUN  <= '0';
          when( "01" ) =>                         -- RESET
            CPU_RESET <= '1';
--            RUN  <= '0';
          when( "10" ) =>                         -- STEP/RUN
            STEP <= '1';
            RUN  <= '1';
          when others =>                          -- RUN
            RUN  <= '1';
        end case;
        
      else
        if( STEP='1' ) then                       -- STEPŝƂ͒~
          STEP <= '0';
          RUN  <= '0';
        end if;
        CPU_RESET <= '0';                         -- RESET
        
      end if;
    end if;
  end process;
  
  
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( WE='1' and ADR(0)='0' ) then
        MWDATA_H <= MWDATA;                       -- [16rbgŏނߏʃoCgb`
      end if;
    end if;
  end process;
  
  
  
end RTL;

