----------------------------------------------------------------------------------
--  
--        alu.vhd        Zs
--  
--        (c)2011/08/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
----------------------------------------------------------------------------------
--
--Selected Device : 3s200avq100-5 
--
-- Number of Slices:                       46  out of   1792     2%  
-- Number of 4 input LUTs:                 88  out of   3584     2%  
-- Number of IOs:                          90
-- Number of bonded IOBs:                  88  out of     68   129% (*) 
-- Number of MULT18X18SIOs:                 1  out of     16     6%  
--
--   Minimum period: No path found
--   Minimum input arrival time before clock: No path found
--   Maximum output required time after clock: No path found
--   Maximum combinational path delay: 14.286ns
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity alu is
  Port (
    RESET       : in  STD_LOGIC;
    CLK2X       : in  STD_LOGIC;
    CLK         : in  STD_LOGIC;
    
    ALU_OP      : in  STD_LOGIC_VECTOR (3 downto 0);
    ALU_INA     : in  STD_LOGIC_VECTOR (15 downto 0);   -- Z A
    ALU_INB     : in  STD_LOGIC_VECTOR (15 downto 0);   -- Z B
    ALU_INCARRY : in  STD_LOGIC;                        -- L[
    ALU_DIVA    : in  STD_LOGIC_VECTOR (31 downto 0);   -- Z 폜
    ALU_DIVND   : in  STD_LOGIC;                        -- Z ̓f[^L
    
    ALU_OUT     : out STD_LOGIC_VECTOR (15 downto 0);   -- Z
    ALU_CARRY   : out STD_LOGIC;                        -- ZʂɃL[
    ALU_ZERO    : out STD_LOGIC;                        -- Zʂ[
    ALU_MULOUT  : out STD_LOGIC_VECTOR (15 downto 0);   -- Zo͏16bit
    ALU_DIVR    : out STD_LOGIC_VECTOR (15 downto 0);   -- Z ]
    ALU_DIVOD   : out std_logic                         -- Z o̓f[^L
  );
end alu;


architecture RTL of alu is
  
  signal ALU_OUT1     : std_logic_VECTOR(16 downto 0);       -- 
  signal MULINA       : std_logic_VECTOR(17 downto 0);       -- 
  signal MULINB       : std_logic_VECTOR(17 downto 0);       -- 
  signal MULOUT       : std_logic_VECTOR(35 downto 0);       -- 
  
  signal DIV_Q        : std_logic_VECTOR(15 downto 0);       -- 
  
  component div
    port (
      CLK : in  std_logic;                       -- 
      ND  : in  std_logic;                       -- ̓f[^L
      A   : in  std_logic_vector( 31 downto 0 ); -- 폜          dividend
      B   : in  std_logic_vector( 15 downto 0 ); --             divisor
      Q   : out std_logic_vector( 15 downto 0 ); --               quotient 
      R   : out std_logic_vector( 15 downto 0 ); -- ]            remainder 
      OD  : out std_logic                        -- o̓f[^L
    );
  end component;


begin
  
  u0 : MULT18X18
  port map (
    P => MULOUT,  -- 36-bit multiplier output
    A => MULINA,  -- 18-bit multiplier input
    B => MULINB   -- 18-bit multiplier input
  );
  
  MULINA <= "00"&ALU_INA;
  MULINB <= "00"&ALU_INB;
  
  
  u1 : div
  port map (
    CLK   => CLK2X,
    ND    => ALU_DIVND,       -- ̓f[^L
    A     => ALU_DIVA,        -- 폜          dividend
    B     => ALU_INB,         --             divisor
    Q     => DIV_Q,           --               quotient 
    R     => ALU_DIVR,        -- ]            remainder 
    OD    => ALU_DIVOD        -- o̓f[^L
  );
  
  
  -----------------------------------------------------------------------------
  --    Zsi`ktj
  -----------------------------------------------------------------------------
  ALU_OUT1 <= ("0"&ALU_INA) + ("0"&ALU_INB) + ALU_INCARRY when( ALU_OP=X"1" ) else   -- ADD
              ("0"&ALU_INA) - ("0"&ALU_INB) - ALU_INCARRY when( ALU_OP=X"2" or ALU_OP=X"3" ) else   -- SUB/CMP
--            ALU_INA and ALU_INB     when( ALU_OP=X"4" ) else   -- AND
--            ALU_INA or  ALU_INB     when( ALU_OP=X"5" ) else   -- OR
--            ALU_INA xor ALU_INB     when( ALU_OP=X"6" ) else   -- XOR
--            (not ALU_INA) + ALU_INB when( ALU_OP=X"7" ) else   -- NADD
              MULOUT(16 downto 0) when( ALU_OP=X"8" ) else   -- MUL
              "0"&DIV_Q           when( ALU_OP=X"9" ) else   -- DIV
              "0"&ALU_INB;                                   -- MOV
  
  ALU_OUT    <= ALU_OUT1(15 downto 0);
  
  ALU_MULOUT <= MULOUT(31 downto 16);
  
  ALU_CARRY  <= '1' when( ALU_OP=X"8" and MULOUT(31 downto 17)/="000000000000000" ) else -- Zł̓I[o[t[\
                ALU_OUT1(16);
  
  ALU_ZERO   <= '1' when( ALU_OUT1(15 downto 0 )=X"0000" ) else '0';
  
  
end RTL;
