----------------------------------------------------------------------------------
--  
--        cpu_div.vhd        ȂZ
--  
--        (c)2011/06/10  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--        A(32)  B(16) = Q(16) ... R(16)   ilatency=19j
--        A ̏16rbg B 菬
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;


------------------------------------------------------------------------------
entity div is 
  port (
    CLK : in  std_logic;                       -- 
    ND  : in  std_logic;                       -- ̓f[^L
    A   : in  std_logic_vector( 31 downto 0 ); -- 폜          dividend
    B   : in  std_logic_vector( 15 downto 0 ); --             divisor
    Q   : out std_logic_vector( 15 downto 0 ); --               quotient 
    R   : out std_logic_vector( 15 downto 0 ); -- ]            remainder 
    OD  : out std_logic                        -- o̓f[^L
  );
end div;


------------------------------------------------------------------------------
architecture RTL of div is
  
  signal RQ     : std_logic_vector( 32 downto 0 ); -- ](Remainder)Ə(Quotient)
  signal A_B    : std_logic_vector( 16 downto 0 ); -- p +1 bit Kv
  signal N      : std_logic_vector(  4 downto 0 ); -- [vJE^[
  
  
begin
  
  A_B <= RQ(32 downto 16) - B;
  
  Q  <= RQ( 15 downto  0);    --     quotient 
  R  <= RQ( 32 downto 17);    -- ]  remainder 
  
  ------------------------------------------------------------------
  --    Z
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( ND='1' ) then
        RQ <= "0" & A;
        if( A=X"0000" ) then            -- A [̂Ƃ͏][
          N  <= "11111";
          OD <= '1';
        else
          N  <= (others => '0');
          OD <= '0';
        end if;
        
      elsif( N(4)='0' or N(0)='0' ) then                      -- (N/="10001") 17JԂ
        if( A_B(16) = '0' ) then                              -- A >= B
          RQ <= A_B( 15 downto 0 ) & RQ(15 downto 0 ) & "1";  -- ɏĂ
        else                                                  -- A < B
          RQ <= RQ( 31 downto 0 ) & "0";
        end if;
        N <= N+1;
        
      else
        OD <= '1';
      end if;
      
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------

