--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   07:57:37 09/10/2011
-- Design Name:   
-- Module Name:   D:/ogchan/WorkShop/ISE/APB2V2_pai/cpu_div_tb.vhd
-- Project Name:  APB2V2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: div
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY cpu_div_tb IS
END cpu_div_tb;
 
ARCHITECTURE behavior OF cpu_div_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT div
    PORT(
         CLK : IN  std_logic;
         ND : IN  std_logic;
         A : IN  std_logic_vector(31 downto 0);
         B : IN  std_logic_vector(15 downto 0);
         Q : OUT  std_logic_vector(15 downto 0);
         R : OUT  std_logic_vector(15 downto 0);
         OD : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal CLK : std_logic := '0';
   signal ND : std_logic := '0';
   signal A : std_logic_vector(31 downto 0) := (others => '0');
   signal B : std_logic_vector(15 downto 0) := (others => '0');

 	--Outputs
   signal Q : std_logic_vector(15 downto 0);
   signal R : std_logic_vector(15 downto 0);
   signal OD : std_logic;

   -- Clock period definitions
   constant CLK_period : time := 10 ns;
 
  -----------------------------------------------------------
  constant N : integer := 8;  -- ̓f[^
  
  subtype D16 is STD_LOGIC_VECTOR (31 downto 0);
  type DATATABLE is array (0 to 2*N-1 ) of D16;
  
  constant DATA :DATATABLE := (         -- 
    X"00010002", X"00000005",  -- 0x3333 ... 0x0003
    X"12345678", X"00001234",  -- 0x0004 ... 0x0DA8  ̓f[^G[̏ꍇ
    X"01234567", X"00001234",  -- 0x1000 ... 0x0567
    X"00112233", X"00000012",  -- 0xF3AD ... 0x0009
    X"0000A000", X"00000000",  -- 0xFFFF ... 0xA000   ł̂???
    X"00000000", X"0000000A",  -- 0x0000 ... 0x0000
    X"0000A000", X"00009000",  -- 0x0001 ... 0x1000
    X"1000A000", X"00009000"   -- 0x1C72 ... 0x8000
  );
  
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: div PORT MAP (
          CLK => CLK,
          ND => ND,
          A => A,
          B => B,
          Q => Q,
          R => R,
          OD => OD
        );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      
      ND    <= '0';
      wait for CLK_period*1;
      
      for i in 0 to N-1 loop
        A    <= DATA(2*i);
        B    <= DATA(2*i+1)(15 downto 0);
        ND   <= '1';
        wait for CLK_period;
        ND   <= '0';
        wait for CLK_period*20;
      end loop;
      
      --wait for CLK_period*5;
      assert (false) report "Simulation End!" severity failure;
   end process;

END;
