----------------------------------------------------------------------------------
--  
--        cpu_reg.vhd        bot̃WX^[
--  
--        (c)2011/08/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity reg is
  Port (
    RESET       : in  STD_LOGIC;
    CLK         : in  STD_LOGIC;
    
    R_NA        : in  STD_LOGIC_VECTOR (3 downto 0);  -- WX^[ԍ A
    R_NB        : in  STD_LOGIC_VECTOR (3 downto 0);  -- WX^[ԍ B
    R_WE        : in  STD_LOGIC;                      -- WX^[ A ݃Cl[u
    R_DIN       : in  STD_LOGIC_VECTOR (15 downto 0); -- WX^[ A ݃f[^
    
    R_DOUTA     : out STD_LOGIC_VECTOR (15 downto 0); -- WX^[ǂݏof[^ A
    R_DOUTB     : out STD_LOGIC_VECTOR (15 downto 0); -- WX^[ǂݏof[^ B
    R_14        : out std_logic_vector (15 downto 0); -- WX^[ SIZE(r14) ǂݏof[^
    R_15        : out STD_LOGIC_VECTOR (15 downto 0)  -- WX^[ R15(SP) ǂݏof[^
  );
end reg;


architecture RTL of reg is
  
  signal R0           : std_logic_VECTOR(15 downto 0);
  signal R1           : std_logic_VECTOR(15 downto 0);
  signal R2           : std_logic_VECTOR(15 downto 0);
  signal R3           : std_logic_VECTOR(15 downto 0);
  signal R4           : std_logic_VECTOR(15 downto 0);
  signal R5           : std_logic_VECTOR(15 downto 0);
  signal R6           : std_logic_VECTOR(15 downto 0);
  signal R7           : std_logic_VECTOR(15 downto 0);
  signal R8           : std_logic_VECTOR(15 downto 0);
  signal R9           : std_logic_VECTOR(15 downto 0);
  signal R10          : std_logic_VECTOR(15 downto 0);
  signal R11          : std_logic_VECTOR(15 downto 0);
  signal R12          : std_logic_VECTOR(15 downto 0);
  signal R13          : std_logic_VECTOR(15 downto 0);
  signal R14          : std_logic_VECTOR(15 downto 0);
  signal R15          : std_logic_VECTOR(15 downto 0);
  
  
begin
  
  
  -----------------------------------------------------------------------------
  --    WX^[ r0..15  ǂݏ
  -----------------------------------------------------------------------------
  R_DOUTA <= R0  when( R_NA=X"0" ) else
             R1  when( R_NA=X"1" ) else
             R2  when( R_NA=X"2" ) else
             R3  when( R_NA=X"3" ) else
             R4  when( R_NA=X"4" ) else
             R5  when( R_NA=X"5" ) else
             R6  when( R_NA=X"6" ) else
             R7  when( R_NA=X"7" ) else
             R8  when( R_NA=X"8" ) else
             R9  when( R_NA=X"9" ) else
             R10 when( R_NA=X"A" ) else
             R11 when( R_NA=X"B" ) else
             R12 when( R_NA=X"C" ) else
             R13 when( R_NA=X"D" ) else
             R14 when( R_NA=X"E" ) else
             R15;
  
  R_DOUTB <= R0  when( R_NB=X"0" ) else
             R1  when( R_NB=X"1" ) else
             R2  when( R_NB=X"2" ) else
             R3  when( R_NB=X"3" ) else
             R4  when( R_NB=X"4" ) else
             R5  when( R_NB=X"5" ) else
             R6  when( R_NB=X"6" ) else
             R7  when( R_NB=X"7" ) else
             R8  when( R_NB=X"8" ) else
             R9  when( R_NB=X"9" ) else
             R10 when( R_NB=X"A" ) else
             R11 when( R_NB=X"B" ) else
             R12 when( R_NB=X"C" ) else
             R13 when( R_NB=X"D" ) else
             R14 when( R_NB=X"E" ) else
             R15;
  
  R_14 <= R14;
  R_15 <= R15;
  
  -- WX^[ɏ
  process( RESET, CLK ) begin
    if( rising_edge(CLK) ) then
      if( RESET='1') then
        R0 <= ( others => '0');
        R1 <= ( others => '0');
        R2 <= ( others => '0');
        R3 <= ( others => '0');
        R4 <= ( others => '0');
        R5 <= ( others => '0');
        R6 <= ( others => '0');
        R7 <= ( others => '0');
        R8 <= ( others => '0');
        R9 <= ( others => '0');
        R10<= ( others => '0');
        R11<= ( others => '0');
        R12<= ( others => '0');
        R13<= ( others => '0');
        R14<= ( others => '0');
        R15<= ( others => '0');
      elsif( R_WE='1' ) then
        case R_NA is
          when( X"0" ) => R0<=R_DIN;
          when( X"1" ) => R1<=R_DIN;
          when( X"2" ) => R2<=R_DIN;
          when( X"3" ) => R3<=R_DIN;
          when( X"4" ) => R4<=R_DIN;
          when( X"5" ) => R5<=R_DIN;
          when( X"6" ) => R6<=R_DIN;
          when( X"7" ) => R7<=R_DIN;
          when( X"8" ) => R8<=R_DIN;
          when( X"9" ) => R9<=R_DIN;
          when( X"A" ) => R10<=R_DIN;
          when( X"B" ) => R11<=R_DIN;
          when( X"C" ) => R12<=R_DIN;
          when( X"D" ) => R13<=R_DIN;
          when( X"E" ) => R14<=R_DIN;
          when others  => R15<=R_DIN;
        end case;
      end if;
    end if;
  end process;
  
  
end RTL;
