--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:33:35 09/06/2011
-- Design Name:   
-- Module Name:   D:/ogchan/WorkShop/ISE/APB2V2_pai/cpu_tb.vhd
-- Project Name:  APB2V2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: cpu
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY cpu_tb IS
END cpu_tb;
 
ARCHITECTURE behavior OF cpu_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT cpu
    PORT(
         RESET : IN  std_logic;
         CLK2X   : in  std_logic;
         CLK : IN  std_logic;
         RUNNING : out std_logic;
         CE : IN  std_logic;
         WE : IN  std_logic;
         ADR : IN  std_logic_vector(15 downto 0);
         MWDATA : IN  std_logic_vector(7 downto 0);
         MRDATA : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal RESET : std_logic := '0';
   signal CLK2X : std_logic := '0';
   signal CLK : std_logic := '0';
   signal CE : std_logic := '0';
   signal WE : std_logic := '0';
   signal ADR : std_logic_vector(15 downto 0) := (others => '0');
   signal MWDATA : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal RUNNING : std_logic;
   signal MRDATA : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant CLK_period : time := 10 ns;
  
  
  -----------------------------------------------------------
  constant N : integer := 109;                      -- ͋@B
  
  subtype D16 is STD_LOGIC_VECTOR (15 downto 0);
  type OPTABLE is array (0 to N-1 ) of D16;
  
  constant OP :OPTABLE := (             -- 
X"03FF",
X"00FF",
X"03BF",
X"0020",
X"003F",
X"1840",
X"0200",
X"007F",
X"0010",
X"00B5",
X"E020",
X"003F",
X"1080",
X"0074",
X"00BF",
X"00EF",
X"E020",
X"0040",
X"0008",
X"2821",
X"004E",
X"1071",
X"8075",
X"E048",
X"9074",
X"0381",
X"003F",
X"0100",
X"9831",
X"C800",
X"C1FF",
X"0000",
X"0000",
X"F100",
X"F101",
X"F102",
X"F103",
X"F104",
X"F105",
X"F106",
X"00FF",
X"0100",
X"013F",
X"08C0",
X"08F0",
X"04C1",
X"0171",
X"01B1",
X"98C2",
X"8082",
X"0823",
X"1172",
X"98C2",
X"0923",
X"9905",
X"C208",
X"31B1",
X"CA03",
X"2824",
X"01B0",
X"C1F6",
X"1824",
X"01B1",
X"C1F3",
X"F906",
X"F905",
X"F904",
X"F903",
X"F902",
X"F901",
X"F900",
X"F000",
X"0000",
X"F100",
X"F101",
X"F102",
X"F103",
X"F104",
X"00BF",
X"0100",
X"04B0",
X"00F4",
X"0110",
X"30F4",
X"CA02",
X"813F",
X"1000",
X"30F3",
X"CA02",
X"813F",
X"0100",
X"30F2",
X"CA02",
X"813F",
X"0010",
X"1484",
X"0430",
X"883A",
X"20F1",
X"CBEE",
X"10B1",
X"2074",
X"CFE9",
X"F904",
X"F903",
X"F902",
X"F901",
X"F900",
X"F000"


  );
  
 
 signal adrs:std_logic_vector(15 downto 0) := X"8000";
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: cpu PORT MAP (
          RESET => RESET,
          CLK2X => CLK2X,
          CLK => CLK,
          RUNNING => RUNNING,
          CE => CE,
          WE => WE,
          ADR => ADR,
          MWDATA => MWDATA,
          MRDATA => MRDATA
        );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK2X <= '0';
		CLK   <= '0';
--		wait for CLK_period/4;
--		CLK2X <= '1';
--		CLK <= '0';
--		wait for CLK_period/4;
--		CLK2X <= '0';
--		CLK <= '1';
		wait for CLK_period/2;
		CLK2X <= '1';
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      
      RESET <= '1';
      wait for CLK_period*1;
      RESET <= '0';
      
      WE  <= '1';
      for i in 0 to N-1 loop
        ADR <= adrs;
        adrs <= adrs + 1;
        MWDATA <= OP( i )(15 downto 8) ;
        wait for CLK_period;
        ADR <= adrs;
        adrs <= adrs + 1;
        MWDATA <= OP( i )(7 downto 0) ;
        wait for CLK_period;
      end loop;
      WE  <= '0';
      
      CE  <= '1';
      WE  <= '1';
      ADR <= X"0000";
      MWDATA <= X"03";   -- RUN
      wait for CLK_period;
      CE  <= '0';
      WE  <= '0';
      wait for CLK_period;
      
      
      wait for CLK_period*200000;
      
      assert (false) report "Simulation End!" severity failure;
   end process;

END;
