--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:39:16 06/08/2011
-- Design Name:   
-- Module Name:   D:/ogchan/WorkShop/ISE/APBV2/spi_testbench.vhd
-- Project Name:  APBV2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: spi
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY spi_testbench IS
END spi_testbench;
 
ARCHITECTURE behavior OF spi_testbench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT spi
    PORT(
         RESET : IN  std_logic;
         CLK : IN  std_logic;
         CS_X : IN  std_logic;
         SCK : IN  std_logic;
         SI : IN  std_logic;
         SO : OUT  std_logic;
         MWE : OUT  std_logic;
         MCE : OUT  std_logic_vector(15 downto 0);
         MEME : OUT  std_logic_vector(7 downto 0);
         MWDATA : OUT  std_logic_vector(7 downto 0);
         MRDATA : IN  std_logic_vector(7 downto 0);
         MADR : OUT  std_logic_vector(15 downto 0);
         DEBUG : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal RESET : std_logic := '0';
   signal CLK : std_logic := '0';
   signal CS_X : std_logic := '0';
   signal SCK : std_logic := '0';
   signal SI : std_logic := '0';
   signal MRDATA : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal SO : std_logic;
   signal MWE : std_logic;
   signal MCE : std_logic_vector(15 downto 0);
   signal MEME : std_logic_vector(7 downto 0);
   signal MWDATA : std_logic_vector(7 downto 0);
   signal MADR : std_logic_vector(15 downto 0);
   signal DEBUG : std_logic;
   
   -- Clock period definitions
   constant CLK_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: spi PORT MAP (
          RESET => RESET,
          CLK => CLK,
          CS_X => CS_X,
          SCK => SCK,
          SI => SI,
          SO => SO,
          MWE => MWE,
          MCE => MCE,
          MEME => MEME,
          MWDATA => MWDATA,
          MRDATA => MRDATA,
          MADR => MADR,
          DEBUG => DEBUG
        );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
      variable d : std_logic_vector(39 downto 0);
      
   begin		
      
      RESET <= '1';
      CS_X  <= '1';
      MRDATA <= (others => '0');
      wait for CLK_period*2;	
      RESET <= '0';
      wait for CLK_period;	
      
      ---------------------------------------------- cmd = 0x02 adr=0x1234 data=0x5678
      d := X"02123F5678";
      CS_X <= '0';
      wait for CLK_period;	
      for i in 0 to 39 loop
        SI   <= d(39-i);
        SCK  <= '0';
        wait for CLK_period*4;	
        SCK  <= '1';
        wait for CLK_period*4;	
      end loop;
      CS_X  <= '1';
      wait for CLK_period*4;
      ---------------------------------------------- 
      
      
      ---------------------------------------------- cmd = 0x03 adr=0x000F data=0x1234
      d := X"03000F1234";
      CS_X <= '0';
      MRDATA <= X"A4";
      wait for CLK_period;	
      for i in 0 to 39 loop
        SI   <= d(39-i);
        SCK  <= '0';
        wait for CLK_period*4;	
        SCK  <= '1';
        wait for CLK_period*4;	
      end loop;
      CS_X  <= '1';
      wait for CLK_period*4;
      ----------------------------------------------
      
      
      
      
      wait for CLK_period*20;
      assert (false) report "Simulation End!" severity failure;
      
   end process;

END;
